import os
#import sys
from Testing import ZopeTestCase
from Globals import package_home
from Products.CMFPlone.tests import PloneTestCase

#from Products.PloneRSSPortlet.browser.interfaces import IRSSFeed
#from zope.app.testing import setup
#from zope.app.component.hooks import setSite
#from zope.app.testing import ztapi
#from zope.component import provideAdapter
#from zope.publisher.interfaces import IRequest

from Products.PloneRSSPortlet import browser
#from Products.PloneRSSPortlet import content
from Products.PloneRSSPortlet.config import product_globals
from Products.PloneTestCase.PloneTestCase import setupPloneSite

ZopeTestCase.installProduct('PloneRSSPortlet')
PloneTestCase.setupPloneSite(products=['PloneRSSPortlet'])

feed = open(os.path.join(package_home(product_globals),'tests', 'rss.xml'), 'r')

class TestRSSFeed(PloneTestCase.PloneTestCase):

    def afterSetUp(self):
        setupPloneSite()
        self.setRoles('Manager')
        self.folder.invokeFactory('RSSFeedRecipe', id="feed1",
                title="title1", feedURL=feed, entriesSize=3)

        
    def testRSSFeed(self):
        view = browser.rss.RSSFeed(self.folder.feed1, self.app.REQUEST)
        feed = view.getFeed()
        result = len(feed)
        answer = 3
        message = "%s != %s" % (result, answer)
        self.failIf( result != answer, message)


        result = feed[0].keys()
        result.sort()
        answer = self.folder.feed1.getAttributesMapping().keys()
        answer.sort()
        result = [ k for k in result
                      if k in answer ]

        message = "%s != %s" % (result, answer)
        self.failIf( result != answer, message)

def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestRSSFeed))
    return suite

if __name__ == '__main__':
    test_suite()
